// UnknownImage.cxx

#warning UnknownImage.cxx is a reimplementation of the \
headerless file images/Fl_Guess_Image.cxx

#include <config.h>
#include <fltk/x.h>
#include <fltk/draw.h>
#include <fltk/SharedImage.h>
#include <fltk/xbmImage.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
using namespace fltk;

// Bitmap used when we couldn't guess the filetype
#define nosuch_width 16
#define nosuch_height 16
static unsigned char nosuch_bits[] = {
   0xff, 0xf0, 0x81, 0x88, 0xd5, 0x90, 0x69, 0xa8, 0x55, 0x94, 0x69, 0xaa,
   0x55, 0x94, 0x69, 0xaa, 0xd5, 0x94, 0xa9, 0xa8, 0x55, 0x95, 0xa9, 0xa9,
   0x55, 0x95, 0xa9, 0xab, 0x01, 0x81, 0xff, 0xff};

xbmImage nosuch_bitmap(nosuch_bits, nosuch_width, nosuch_height);

class UnknownImage {
public:
  static bool test(const uchar*, unsigned =0) { return 1; };
  static fltk::SharedImage* get(const char*, const uchar* = 0) {
    return (fltk::SharedImage*)(void*)&nosuch_bitmap;
  };
};

ImageType fltk::image_filetypes[] = {
  { "xpm", xpmFileImage::test, xpmFileImage::get},
  { "gif", gifImage::test, gifImage::get},
  { "png", pngImage::test, pngImage::get},
  { "bmp", bmpImage::test, bmpImage::get},
  { "jpeg",jpegImage::test, jpegImage::get},
  { 0, UnknownImage::test, UnknownImage::get }
};

FL_IMAGES_API ImageType* fltk::guess_image(const char* name, const uchar* datas)
{
  uchar* read_data = 0;
  const uchar* test_data = datas;
  unsigned size = 1024;
  if (!datas) {
    FILE* fp = fopen(name, "rb");
    if (!fp)
      return	image_filetypes + 
				sizeof(image_filetypes)/sizeof(image_filetypes[0]) - 1;
    test_data = read_data = new uchar[1025];
    read_data[1024] = 0; // null-terminate so strstr() works
    size = fread(read_data, 1, size, fp);
    fclose(fp);
  }
  ImageType* ft;
  for (ft=image_filetypes; ft->name; ft++)
    if (ft->test(test_data, size)) break;
  delete[] read_data;
  return ft;
}

//
// End of "$Id: Fl_Guess_Image.cxx 6144 2008-07-16 04:52:58Z spitzak $"
//
